#include "PseudoEcgDataReadIn.hpp"
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <cassert>
#include "UblasVectorInclude.hpp"
#include "Exception.hpp"

void PseudoEcgDataReadIn::LoadDataFromFile(std::string file)
{
	std::ifstream input;
	input.open(file.c_str());
	if(!input.good())
	{
		EXCEPTION("Couldn't open data file: " + file);
	}

	while (input.good())
	{
		std::string this_line;
		getline(input, this_line);

		std::stringstream line(this_line);

		LoadALine(line);
	}

}

unsigned PseudoEcgDataReadIn::GetNumberOfValues(void)
{
	return mVoltage.size();
}
double PseudoEcgDataReadIn::GetValues(unsigned Index)
{
	//assert(Index < GetNumberOfValues());
	return mVoltage[Index];
}
