#ifdef CHASTE_CVODE

#ifndef _STEADYSTATE_HPP_
#define _STEADYSTATE_HPP_
#include "RegularStimulus.hpp"
#include "AbstractCvodeCell.hpp"
#include "shannon_wang_puglisi_weber_bers_2004Cvode.hpp"
#include <boost/shared_ptr.hpp>

class SteadyState
{
protected:
	boost::shared_ptr<AbstractCvodeCell> mpModel;
	unsigned mNumberOfPaces;

public:

//Constructor
	SteadyState(boost::shared_ptr<AbstractCvodeCell> pModel);

//Method to return number of paces needed until steady state is reached
	unsigned GetNumberOfPaces();

	//Method to run model to steady state
	virtual void RunToSteadyState();

	//Destructor
	virtual ~SteadyState(){};
};

#endif // _STEADYSTATE_HPP_

#endif // CHASTE_CVODE
