function plottingEC10plot()
%Input results file name here
file = 'PatchXpress_2_Parameter_multiple';
maxconc = 0;
% Checks which assay type the results correspond to and extracts details of
% the name of the compounds included for evaluation of that assay and the
% number of doses for which it is simulated
PX = strfind(file,'PatchXpress');
IW = strfind(file,'IonWorks');
QS = strfind(file,'QSAR');
if PX ==1
    fid = fopen('PatchXpress_Data_Matrix.dat');
    Namedata = textscan(fid, '%f %s %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f', '\t');
    fclose(fid);
    Names = Namedata{1};
    SimDoseNumber = Namedata{9};
    NamesMatrix = Names;
end
if IW ==1
    fid = fopen('IonWorks_Data_Matrix.dat');
    Namedata = textscan(fid, '%f %s %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f', '\t');
    fclose(fid);
    Names = Namedata{1};
    SimDoseNumber = Namedata{9};
    NamesMatrix = Names;
end
if QS ==1
    fid = fopen('QSAR_Data_Matrix.dat');
    Namedata = textscan(fid, '%f %s %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f', '\t');
    fclose(fid);
    Names = Namedata{1};
    SimDoseNumber = Namedata{9};
    NamesMatrix = Names;
end

% Opens and reads in rabbit wedge data to extract concentrations tested and
% the change in QT interval measured at that concentration for each
% compound
fid = fopen('Rabbit_Wedge_Data.dat');
RabbitWedgeData = textscan(fid, '%f %f %f %f','headerlines',1);
fclose(fid);

WedgeNames = RabbitWedgeData{1};
RabbitWedgeDataMatrix{1} = RabbitWedgeData{2};
RabbitWedgeDataMatrix{2} = RabbitWedgeData{3};
RabbitWedgeDataMatrix{3} = RabbitWedgeData{4};
RabbitWedgeMatrix = cell2mat(RabbitWedgeDataMatrix);

Concs = RabbitWedgeMatrix(:,1);
PercentChange = RabbitWedgeMatrix(:,3);

m = 1;
% For each compound, concentrations tested in the rabbit wedge experiments
% and corresponding percent change in QT interval recorded are determined
for i = 1:length(NamesMatrix)
    d = 1;
    
    for j = 1:length(WedgeNames)
        
        if strmatch(NamesMatrix(i),WedgeNames(j))
            
            DataDoseExtract(m,d) = Concs(j);
            QTDataExtract(m,d) = PercentChange(j);
            d = d+1;
            
        end
    end
    DoseNumber(m) = d-1;
    m = m+1;
end

%Changes to results folder
cd(file);

% Extracts information about all the files in the results folder
for o = 1:length(dir)
    dirData = dir;
end

% Forms matrices of concentrations tested and percent change in QT interval
% recorded for each compound
for t = 1:length(Names)
    
    expmatrix(1:DoseNumber(t),t) =  QTDataExtract(t,1:DoseNumber(t));
    expconcs(1:DoseNumber(t),t) = DataDoseExtract(t,1:DoseNumber(t));
end
% Determines maximum concentration tested in rabbit wedge experiments at
% which all of the % changes in the QT interval recorded is between -10 and
% 10%
if abs(expmatrix(1:DoseNumber(t),t))<10
    for i = 1:DoseNumber(t)
        if (max(expconcs(i,t))>maxconc)
            maxconc = max(expconcs(i,t));
        end
        
    end
end

% Iteratively goes through each compound folder in the results folder
% extracting the simulation results.
for t  = 1:length(Names)
    N = num2str(Names(t));
    C = 'Compound_';
    Name=strcat(C,N);
    for h = 1:length(dir)
        foldername =dirData(h).name;
        if strcmp(Name,foldername)==1
            
            cd(foldername);
            Results_File = strcat('APD90_Results.dat');
            
            fid = fopen(Results_File);
            M = textscan(fid,'%f %f %f %f');
            SimDoseNumber(t);
            simmatrix(1:SimDoseNumber(t),t) = M{3};
            simconcs(1:SimDoseNumber(t),t) = M{1};
            fclose(fid);
            cd ..
            
        end
    end
    
    % The simulation and experimental results for each compound are
    % classified into which of the four quadrants on the EC10 plot they
    % would be plotted in where simulation and experimental results both
    % show more than a 10% change or whether they will be plotted along the
    % axes where only one of the simulation or experimental results shows
    %more than a 10% change.
    
    z=0;
    y=0;
    a = 0;
    b = 0;
    % Checking for compounds with more than 10% change in simulation results
    for l = 1:length(simmatrix(:,t))
        if abs(simmatrix(l,t))>10
            z=1;
        end
        % Checks is this is a positive or negative change
        if simmatrix(l,t) <-10
            a =- 1;
        end
        if simmatrix(l,t) > 10
            a = 1;
        end
    end
    % Checking for compounds with more than 10% change in experimental results
    for m = 1:length(expmatrix(:,t))
        if abs(expmatrix(m,t))>10
            y=1;
            
        end
        % Checks if this is a positive or negative change
        if expmatrix(m,t) <-10
            b =- 1;
        end
        if expmatrix(m,t) > 10
            b = 1;
        end
        
        
    end
    
    %Compounds plotted in quadrant 1 - both simulation and experimenal results
    %show more than a 10% change
    
    if y==1 && z==1 && a ==1 && b ==1
        subplot(2,2,2)
        
        % Interpolates to determine EC10 for simulation and experimental
        % results
        EC10sim = interp1(simmatrix(1:SimDoseNumber(t),t),simconcs(1:SimDoseNumber(t),t),10);
        EC10exp = interp1(expmatrix(1:DoseNumber(t),t),expconcs(1:DoseNumber(t),t),10);
        hold on
        plot(-log10(0.000001*EC10exp),-log10(0.000001*EC10sim),'k*');
        for x = (-log10(maxconc*1e-6)):0.1:8
            y = x;
            plot(x,y,'k-')
            hold on
        end
        for x =(-log10(maxconc*1e-6)):0.01:8
            y = x + 0.5;
            plot(x,y,'k.','MarkerSize',3)
            hold on
        end
        for x =(-log10(maxconc*1e-6)):0.01:8
            y = x - 0.5;
            plot(x,y,'k.','MarkerSize',3)
            hold on
        end
    end
    
    %Compounds plotted in quadrant 3 - both simulation and experimenal results
    %show more than a 10% change
    if y==1 && z==1 && a ==-1 && b ==-1
        subplot(2,2,3)
        
        EC10sim = interp1(simmatrix(1:SimDoseNumber(t),t),simconcs(1:SimDoseNumber(t),t),-10);
        EC10exp = interp1(expmatrix(1:DoseNumber(t),t),expconcs(1:DoseNumber(t),t),-10);
        hold on
        plot(-log10(0.000001*EC10exp),-log10(0.000001*EC10sim),'k*');
        
        
        for x = (-log10(maxconc*1e-6)):0.1:8
            y = x;
            plot(x,y,'k-')
            hold on
        end
        for x =(-log10(maxconc*1e-6)):0.01:8
            y = x + 0.5;
            plot(x,y,'k.','MarkerSize',3)
            hold on
        end
        for x =(-log10(maxconc*1e-6)):0.01:8
            y = x - 0.5;
            plot(x,y,'k.','MarkerSize',3)
            hold on
        end
    end
    % Compounds plotted in quadrant 1  - both simulation and experimenal results
    %show more than a 10% change
    if y==1 && z==1 && a ==1 && b ==-1
        subplot(2,2,1)
        
        EC10sim = interp1(simmatrix(1:SimDoseNumber(t),t),simconcs(1:SimDoseNumber(t),t),10);
        EC10exp = interp1(expmatrix(1:DoseNumber(t),t),expconcs(1:DoseNumber(t),t),-10);
        hold on
        plot(-log10(0.000001*EC10exp),-log10(0.000001*EC10sim),'k*');
    end
    
    %Compounds plotted in quarant 4 - both simulation and experimenal results
    %show more than a 10% change
    if y==1 && z==1 && a ==-1 && b ==1
        subplot(2,2,4)
        
        EC10sim = interp1(simmatrix(1:SimDoseNumber(t),t),simconcs(1:SimDoseNumber(t),t),-10);
        EC10exp = interp1(expmatrix(1:DoseNumber(t),t),expconcs(1:DoseNumber(t),t),10);
        hold on
        plot(-log10(0.000001*EC10exp),-log10(0.000001*EC10sim),'k*');
    end
    
    %Compounds plotted in quadrant 1/2 axis - only simulation results show more than
    %a 10% change
    if y==0 && z==1 && a ==1
        subplot(2,2,1)
        EC10sim = interp1(simmatrix(1:SimDoseNumber(t),t),simconcs(1:SimDoseNumber(t),t),10);
        hold on
        plot((-log10(maxconc*1e-6)),-log10(0.000001*EC10sim),'ko');
    end
    %Compounds plotted in quadrant 3/4 axis - only simulation results show more than
    %a 10% change
    if y==0 && z==1 && a ==-1
        subplot(2,2,4)
        EC10sim = interp1(simmatrix(1:SimDoseNumber(t),t),simconcs(1:SimDoseNumber(t),t),-10);
        hold on
        plot((-log10(maxconc*1e-6)),-log10(0.000001*EC10sim),'ko');
        hold on
    end
    %Compounds plotted in quadrant 1/4 axis - only experimental results show more than
    %a 10% change
    if z==0 && y==1 && b ==1
        subplot(2,2,4)
        EC10exp = interp1(expmatrix(1:DoseNumber(t),t),expconcs(1:DoseNumber(t),t),10);
        hold on
        plot(-log10(0.000001*EC10exp),(-log10(maxconc*1e-6)),'ko');
        
    end
    %Compounds plotted in quadrant 2/3 axis - only experimental results show more than
    %a 10% change
    if z==0 && y==1 && b ==-1
        subplot(2,2,1)
        EC10exp = interp1(expmatrix(1:DoseNumber(t),t),expconcs(1:DoseNumber(t),t),-10);
        hold on
        plot(-log10(0.000001*EC10exp),(-log10(maxconc*1e-6)),'ko');
        
    end
end

subplot(2,2,4)
xlabel('-log10(EC10(M)) from Experimental Results')
subplot(2,2,1)
ylabel('-log10(EC10(M)) from Simulation Results')
subplot(2,2,1)
set(gca,'XDir','reverse')
axis([(-log10(maxconc*1e-6)) 8 (-log10(maxconc*1e-6)) 8])
subplot(2,2,4)
set(gca,'YDir','reverse')
axis([(-log10(maxconc*1e-6)) 8 (-log10(maxconc*1e-6)) 8])
subplot(2,2,2)
axis([(-log10(maxconc*1e-6)) 8 (-log10(maxconc*1e-6)) 8])
subplot(2,2,3)
set(gca,'XDir','reverse')
set(gca,'YDir','reverse')
axis([(-log10(maxconc*1e-6)) 8 (-log10(maxconc*1e-6)) 8])

subplot(2,2,4)
set(gca, 'YTickLabelMode', 'manual', 'YTickLabel', []);
subplot(2,2,1);
set(gca, 'XTickLabelMode', 'manual', 'XTickLabel', []);
subplot(2,2,2)
set(gca, 'XTickLabelMode', 'manual', 'XTickLabel', []);
set(gca, 'YTickLabelMode', 'manual', 'YTickLabel', []);



set(subplot(2,2,3),'position',[0.1,0.1,0.4,0.4]);
set(subplot(2,2,2),'position',[0.5,0.5,0.4,0.4]);
set(subplot(2,2,1),'position',[0.1,0.5,0.4,0.4]);
set(subplot(2,2,4),'position',[0.5 0.1 0.4,0.4]);
 