function preparinginputdata()

% Preparing data fitted for IC50 value only.

% Reads in pIC50 values
fid = fopen('pIC50_Values.dat');
Namedata = textscan(fid, '%f %s %f %f %f %f','headerlines',1);
fclose(fid);
Names = Namedata{1};
Assay = Namedata{2};
DataMatrix{1} = Namedata{3};
DataMatrix{2} = Namedata{4};
DataMatrix{3} = Namedata{5};
DataMatrix{4} = Namedata{6};
pIC50Matrix = cell2mat(DataMatrix);
NamesMatrix = Names;

% Reads in Rabbit Wedge Data
fid = fopen('Rabbit_Wedge_Data.dat');
RabbitWedgeData = textscan(fid, '%f %f %f %f','headerlines',1);
fclose(fid);

WedgeNames = RabbitWedgeData{1};
RabbitWedgeDataMatrix{1} = RabbitWedgeData{2};
RabbitWedgeDataMatrix{2} = RabbitWedgeData{3};
RabbitWedgeDataMatrix{3} = RabbitWedgeData{4};
RabbitWedgeMatrix = cell2mat(RabbitWedgeDataMatrix);

Concs = RabbitWedgeMatrix(:,1);
p = 1;
Name = unique(Names);

% Sorting PatchXpress data which has been fitted for IC50 value only
% Extracting pIC50 values and converting to IC50 values
for i = 1:length(Names)
    if strcmp(Assay(i),'PatchXpress')==1
        PX_Compound_Data(p,2) = 0.5;
        PX_Compound_Data(p,3) = 1e6.*(10.^(-pIC50Matrix(i,1)));
        PX_Compound_Data(p,4) = 1;
        PX_Compound_Data(p,5) = 1e6.*(10.^(-pIC50Matrix(i,2)));
        PX_Compound_Data(p,6) = 1;
        PX_Compound_Data(p,7) = 1e6.*(10.^(-pIC50Matrix(i,3)));
        PX_Compound_Data(p,8) = 1;
        PX_Compounds(p,1) = Names(i);
        p = p+1;
    end
end

% Extracting doses measured in the rabbit wedge experiments
for j = 1:length(PX_Compounds)
    u = 1;
    for i = 1:length(WedgeNames)
        if WedgeNames(i)==PX_Compounds(j)
            PX_Doses(j,u) = Concs(i);
            u=u+1;
        end
    end
end

% Adding the lower does of 0.001 uM, 0.01 uM, 0.1 uM and 1 uM
% if these are not measured in the wedge experiments and if these
% concentrations are not above the maximum concentration tested in
% the wedge experiments.

for i = 1:length(PX_Doses)
    PX_DosesData = unique(PX_Doses(i,:));
    T = any(PX_DosesData(:)>=1);
    G = ismember([0.001 0.01 0.1 1],PX_DosesData(:));
    
    if T == 1 && sum(G) ==0
        PX_ExtraDoses(i,1:4) = [0.001 0.01 0.1 1];
    end
    if T ==1 && G(1)==1 && sum(G) ==1
        PX_ExtraDoses(i,1:3) = [0.01 0.1 1];
    end
    if T ==1 && G(2)==1 && sum(G) ==1
        PX_ExtraDoses(i,1:3) = [0.001 0.1 1];
    end
    if T ==1 && G(3)==1 && sum(G) ==1
        PX_ExtraDoses(i,1:3) = [0.001 0.01 1];
    end
    if T ==1 && G(4)==1 && sum(G) ==1
        PX_ExtraDoses(i,1:3) = [0.001 0.01 0.1];
    end
    if T==1 && G(1) ==1 && G(2)==1 && sum(G) ==2
        PX_ExtraDoses(i,1:2) = [0.1 1];
    end
    if T==1 && G(2) ==1 && G(3)==1 && sum(G) ==2
        PX_ExtraDoses(i,1:2) = [0.001 1];
    end
    if T==1 && G(3) ==1 && G(4)==1 && sum(G) ==2
        PX_ExtraDoses(i,1:2) = [0.001 0.01];
    end
    if T==1 && G(1) ==1 && G(4)==1 && sum(G) ==2
        PX_ExtraDoses(i,1:2) = [0.01 0.1];
    end
    if T==1 && G(1) ==1 && G(3)==1 && sum(G) ==2
        PX_ExtraDoses(i,1:2) = [0.001 1];
    end
    if T==1 && G(2) ==1 && G(4)==1 && sum(G) ==2
        PX_ExtraDoses(i,1:2) = [0.001 0.1];
    end
    if T==1 && G(1)==1&& G(2) ==1 && G(3)==1 && sum(G) ==3
        PX_ExtraDoses(i,1) = [1];
    end
    if T==1 && G(1)==1&& G(2) ==1 && G(4)==1 && sum(G) ==3
        PX_ExtraDoses(i,1) = [0.1];
    end
    if T==1 && G(2)==1&& G(3) ==1 && G(4)==1 && sum(G) ==3
        PX_ExtraDoses(i,1) = [0.001];
    end
    if T==1 && G(1)==1&& G(3) ==1 && G(4)==1 && sum(G) ==3
        PX_ExtraDoses(i,1) = [0.01];
    end
    H = any(PX_DosesData(:)> 0.01);
    R = all(PX_DosesData(:)<1);
    K = ismember([0.1],PX_DosesData(:));
    if H==1 && R ==1  && K(1)==0
        PX_ExtraDoses(i,1) = [0.1];
    end
    H = any(PX_DosesData(:)> 0);
    R = all(PX_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],PX_DosesData(:));
    if H==1 && R ==1  && K(1)==0 && K(2) ==0 && K(3) ==0
        PX_ExtraDoses(i,1:3) = [0.001 0.01 0.1];
    end
    H = any(PX_DosesData(:)> 0);
    R = all(PX_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],PX_DosesData(:));
    if H==1 && R ==1  && K(1)==1 && K(2) ==0 && K(3) ==0
        PX_ExtraDoses(i,1:2) = [0.01 0.1];
    end
    H = any(PX_DosesData(:)> 0);
    R = all(PX_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],PX_DosesData(:));
    if H==1 && R ==1  && K(1)==0 && K(2) ==1 && K(3) ==0
        PX_ExtraDoses(i,1:2) = [0.001 0.1];
    end
    H = any(PX_DosesData(:)> 0);
    R = all(PX_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],PX_DosesData(:));
    if H==1 && R ==1  && K(1)==0 && K(2) ==0 && K(3) ==1
        PX_ExtraDoses(i,1:2) = [0.001 0.01];
    end
    H = any(PX_DosesData(:)> 0);
    R = all(PX_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],PX_DosesData(:));
    if H==1 && R ==1  && K(1)==1 && K(2) ==1 && K(3) ==0
        PX_ExtraDoses(i,1) = [0.1];
    end
    
    H = any(PX_DosesData(:)> 0);
    R = all(PX_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],PX_DosesData(:));
    if H==1 && R ==1  && K(1)== 0 && K(2) ==1 && K(3) ==1
        PX_ExtraDoses(i,1) = [0.001];
    end
    H = any(PX_DosesData(:)> 0);
    R = all(PX_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],PX_DosesData(:));
    if H==1 && R ==1  && K(1)==1 && K(2) ==0 && K(3) ==1
        PX_ExtraDoses(i,1) = [0.01];
    end
    H1 = any(PX_DosesData(:)> 0.001);
    R1 = all(PX_DosesData(:)<0.1);
    K1 = ismember([0.01],PX_DosesData(:));
    if H1==1 && R1 ==1  && K1(1)==0 && G(1) ==1 && G(2)==0
        PX_ExtraDoses(i,1) = [0.01];
    end
    H2 = any(PX_DosesData(:)> 0);
    R2 = all(PX_DosesData(:)<0.01);
    K2 = ismember([0.001],PX_DosesData(:))
    if H1==1 && R1 ==1  && K1(1)==0
        PX_ExtraDoses(i,1) = [0.001];
    end
    H3 = any(PX_DosesData(:)> 0.001);
    R3 = all(PX_DosesData(:)<1);
    K3 = ismember([0.01 0.1],PX_DosesData(:));
    if H3==1 && R3 ==1  && K3(1)==0 && K3(2)==0
        PX_ExtraDoses(i,1:2) = [0.01 0.1];
    end
end
% Data file for prepared input data to be saved to.
filename = 'PatchXpress_Data_Matrix.dat';
fid = fopen(filename,'w');

% Collating all pIC50 values with doses simulations
% for each compound should be performed at.
for i = 1:length(PX_Compounds)
    PX_FullDoseMatrix(i,1:length(unique(nonzeros(PX_ExtraDoses(i,:))))) = unique(nonzeros(PX_ExtraDoses(i,1:length(unique(PX_ExtraDoses(i,:))))));
    PX_FullDoseMatrix(i,(length(unique(nonzeros(PX_ExtraDoses(i,:))))+1):(length(unique(nonzeros(PX_ExtraDoses(i,:))))+length(unique(PX_Doses(i,:))))) = PX_Doses(i,1:length(unique(PX_Doses(i,:))));
    PX_FullDoseMatrix(i,:) = sort(PX_FullDoseMatrix(i,:));
end
% Calculating number of doses (excluding zero) for each compound
for i = 1:length(PX_FullDoseMatrix)
    PX_NumberOfDoses(i,1) = length(nonzeros(PX_FullDoseMatrix(i,:)));
end
% Collating final matrix
for i = 1:length(PX_Compounds)
    PX_Matrix(:,2:8) = PX_Compound_Data(:,2:8);
    PX_Matrix(:,9) = PX_NumberOfDoses + 1;
    PX_Matrix(:,10) = 0;
    ind= find(PX_FullDoseMatrix(i,:)~=0);
    PX_Matrix(i,11:(11.+(max(ind)-min(ind))))= PX_FullDoseMatrix(i,min(ind):max(ind));
end
PX_Matrix(:,1) = PX_Compounds(:,1);

for i = 1:length(PX_Matrix)
    if i~=length(PX_Matrix)
        fprintf(fid,'%.0f %.1f %.6f %.6f %.6f %.6f %.6f %.6f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f \n',PX_Matrix(i,:));
    end
    if i==length(PX_Matrix)
        fprintf(fid,'%.0f %.1f %.6f %.6f %.6f %.6f %.6f %.6f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f',PX_Matrix(i,:));
    end
end
fclose(fid);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Sorting QSAR data which has been fitted for IC50 value only
% Extracting pIC50 values and converting to IC50 values
p = 1;
for i = 1:length(Names)
    if strcmp(Assay(i),'Adamantis')==1
        AD_Compound_Data(p,2) = 0.5;
        AD_Compound_Data(p,3) = 1e6.*(10.^(-pIC50Matrix(i,1)));
        AD_Compound_Data(p,4) = 1;
        AD_Compound_Data(p,5) = 1e6.*(10.^(-pIC50Matrix(i,2)));
        AD_Compound_Data(p,6) = 1;
        AD_Compound_Data(p,7) = 1e6.*(10.^(-pIC50Matrix(i,3)));
        AD_Compound_Data(p,8) = 1;
        AD_Compounds(p,1) = Names(i);
        p = p+1;
    end
end

% Extracting doses measured in the rabbit wedge experiments
for j = 1:length(AD_Compounds)
    u = 1;
    for i = 1:length(WedgeNames)
        if WedgeNames(i)==AD_Compounds(j)
            AD_Doses(j,u) = Concs(i);
            u=u+1;
        end
    end
end

% Adding the lower does of 0.001 uM, 0.01 uM, 0.1 uM and 1 uM
% if these are not measured in the wedge experiments and if these
% concentrations are not above the maximum concentration tested in
% the wedge experiments.

for i = 1:length(AD_Doses)
    AD_DosesData = unique(AD_Doses(i,:));
    T = any(AD_DosesData(:)>=1);
    G = ismember([0.001 0.01 0.1 1],AD_DosesData(:));
    
    if T == 1 && sum(G) ==0
        AD_ExtraDoses(i,1:4) = [0.001 0.01 0.1 1];
    end
    if T ==1 && G(1)==1 && sum(G) ==1
        AD_ExtraDoses(i,1:3) = [0.01 0.1 1];
    end
    if T ==1 && G(2)==1 && sum(G) ==1
        AD_ExtraDoses(i,1:3) = [0.001 0.1 1];
    end
    if T ==1 && G(3)==1 && sum(G) ==1
        AD_ExtraDoses(i,1:3) = [0.001 0.01 1];
    end
    if T ==1 && G(4)==1 && sum(G) ==1
        AD_ExtraDoses(i,1:3) = [0.001 0.01 0.1];
    end
    if T==1 && G(1) ==1 && G(2)==1 && sum(G) ==2
        AD_ExtraDoses(i,1:2) = [0.1 1];
    end
    if T==1 && G(2) ==1 && G(3)==1 && sum(G) ==2
        AD_ExtraDoses(i,1:2) = [0.001 1];
    end
    if T==1 && G(3) ==1 && G(4)==1 && sum(G) ==2
        AD_ExtraDoses(i,1:2) = [0.001 0.01];
    end
    if T==1 && G(1) ==1 && G(4)==1 && sum(G) ==2
        AD_ExtraDoses(i,1:2) = [0.01 0.1];
    end
    if T==1 && G(1) ==1 && G(3)==1 && sum(G) ==2
        AD_ExtraDoses(i,1:2) = [0.001 1];
    end
    if T==1 && G(2) ==1 && G(4)==1 && sum(G) ==2
        AD_ExtraDoses(i,1:2) = [0.001 0.1];
    end
    if T==1 && G(1)==1&& G(2) ==1 && G(3)==1 && sum(G) ==3
        AD_ExtraDoses(i,1) = [1];
    end
    if T==1 && G(1)==1&& G(2) ==1 && G(4)==1 && sum(G) ==3
        AD_ExtraDoses(i,1) = [0.1];
    end
    if T==1 && G(2)==1&& G(3) ==1 && G(4)==1 && sum(G) ==3
        AD_ExtraDoses(i,1) = [0.001];
    end
    if T==1 && G(1)==1&& G(3) ==1 && G(4)==1 && sum(G) ==3
        AD_ExtraDoses(i,1) = [0.01];
    end
    H = any(AD_DosesData(:)> 0.01);
    R = all(AD_DosesData(:)<1);
    K = ismember([0.1],AD_DosesData(:));
    if H==1 && R ==1  && K(1)==0
        AD_ExtraDoses(i,1) = [0.1];
    end
    H = any(AD_DosesData(:)> 0);
    R = all(AD_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],AD_DosesData(:));
    if H==1 && R ==1  && K(1)==0 && K(2) ==0 && K(3) ==0
        AD_ExtraDoses(i,1:3) = [0.001 0.01 0.1];
    end
    H = any(AD_DosesData(:)> 0);
    R = all(AD_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],AD_DosesData(:));
    if H==1 && R ==1  && K(1)==1 && K(2) ==0 && K(3) ==0
        AD_ExtraDoses(i,1:2) = [0.01 0.1];
    end
    H = any(AD_DosesData(:)> 0);
    R = all(AD_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],AD_DosesData(:));
    if H==1 && R ==1  && K(1)==0 && K(2) ==1 && K(3) ==0
        AD_ExtraDoses(i,1:2) = [0.001 0.1];
    end
    H = any(AD_DosesData(:)> 0);
    R = all(AD_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],AD_DosesData(:));
    if H==1 && R ==1  && K(1)==0 && K(2) ==0 && K(3) ==1
        AD_ExtraDoses(i,1:2) = [0.001 0.01];
    end
    H = any(AD_DosesData(:)> 0);
    R = all(AD_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],AD_DosesData(:));
    if H==1 && R ==1  && K(1)==1 && K(2) ==1 && K(3) ==0
        AD_ExtraDoses(i,1) = [0.1];
    end
    
    H = any(AD_DosesData(:)> 0);
    R = all(AD_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],AD_DosesData(:));
    if H==1 && R ==1  && K(1)== 0 && K(2) ==1 && K(3) ==1
        AD_ExtraDoses(i,1) = [0.001];
    end
    H = any(AD_DosesData(:)> 0);
    R = all(AD_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],AD_DosesData(:));
    if H==1 && R ==1  && K(1)==1 && K(2) ==0 && K(3) ==1
        AD_ExtraDoses(i,1) = [0.01];
    end
    H1 = any(AD_DosesData(:)> 0.001);
    R1 = all(AD_DosesData(:)<0.1);
    K1 = ismember([0.01],AD_DosesData(:));
    if H1==1 && R1 ==1  && K1(1)==0 && G(1) ==1 && G(2)==0
        AD_ExtraDoses(i,1) = [0.01];
    end
    H2 = any(AD_DosesData(:)> 0);
    R2 = all(AD_DosesData(:)<0.01);
    K2 = ismember([0.001],AD_DosesData(:));
    if H1==1 && R1 ==1  && K1(1)==0
        AD_ExtraDoses(i,1) = [0.001];
    end
    H3 = any(AD_DosesData(:)> 0.001);
    R3 = all(AD_DosesData(:)<1);
    K3 = ismember([0.01 0.1],AD_DosesData(:));
    if H3==1 && R3 ==1  && K3(1)==0 && K3(2)==0
        AD_ExtraDoses(i,1:2) = [0.01 0.1];
    end
end
% Data file for prepared input data to be saved to.
filename = 'QSAR_Data_Matrix.dat';
fid = fopen(filename,'w');

% Collating all pIC50 values with doses simulations
% for each compound should be performed at.
for i = 1:length(AD_Compounds)
    AD_FullDoseMatrix(i,1:length(unique(nonzeros(AD_ExtraDoses(i,:))))) = unique(nonzeros(AD_ExtraDoses(i,1:length(unique(AD_ExtraDoses(i,:))))));
    AD_FullDoseMatrix(i,(length(unique(nonzeros(AD_ExtraDoses(i,:))))+1):(length(unique(nonzeros(AD_ExtraDoses(i,:))))+length(unique(AD_Doses(i,:))))) = AD_Doses(i,1:length(unique(AD_Doses(i,:))));
    AD_FullDoseMatrix(i,:) = sort(AD_FullDoseMatrix(i,:));
end
% Calculating number of doses (excluding zero) for each compound
for i = 1:length(AD_FullDoseMatrix)
    AD_NumberOfDoses(i,1) = length(nonzeros(AD_FullDoseMatrix(i,:)));
end
% Collating final matrix
for i = 1:length(AD_Compounds)
    AD_Matrix(:,2:8) = AD_Compound_Data(:,2:8);
    AD_Matrix(:,9) = AD_NumberOfDoses + 1;
    AD_Matrix(:,10) = 0;
    ind= find(AD_FullDoseMatrix(i,:)~=0);
    AD_Matrix(i,11:(11.+(max(ind)-min(ind))))= AD_FullDoseMatrix(i,min(ind):max(ind));
end
AD_Matrix(:,1) = AD_Compounds(:,1);

for i = 1:length(AD_Matrix)
    if i ~=length(AD_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f \n',AD_Matrix(i,:))
    end
    if i==length(AD_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f',AD_Matrix(i,:))
    end
end
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Sorting IonWorks data (excluding Iks) which has been fitted for IC50 value only
%Extracting pIC50 values and converting to IC50 values
p = 1;
for i = 1:length(Names)
    if strcmp(Assay(i),'IonWorks_FLIPR')==1
        IW_Compound_Data(p,2) = 0.5;
        IW_Compound_Data(p,3) = 1e6.*(10.^(-pIC50Matrix(i,1)));
        IW_Compound_Data(p,4) = 1;
        IW_Compound_Data(p,5) = 1e6.*(10.^(-pIC50Matrix(i,2)));
        IW_Compound_Data(p,6) = 1;
        IW_Compound_Data(p,7) = 1e6.*(10.^(-pIC50Matrix(i,3)));
        IW_Compound_Data(p,8) = 1;
        IW_Compounds(p,1) = Names(i);
        p = p+1;
    end
end

%Extracting doses measured in the rabbit wedge experiments
for j = 1:length(IW_Compounds)
    u = 1;
    for i = 1:length(WedgeNames)
        if WedgeNames(i)==IW_Compounds(j)
            IW_Doses(j,u) = Concs(i);
            u=u+1;
        end
    end
end

%Adding the lower does of 0.001 uM, 0.01 uM, 0.1 uM and 1 uM
%if these are not measured in the wedge experiments and if these
%concentrations are not above the maximum concentration tested in
%the wedge experiments.

for i = 1:length(IW_Doses)
    IW_DosesData = unique(IW_Doses(i,:));
    T = any(IW_DosesData(:)>=1);
    G = ismember([0.001 0.01 0.1 1],IW_DosesData(:));
    
    if T == 1 && sum(G) ==0
        IW_ExtraDoses(i,1:4) = [0.001 0.01 0.1 1];
    end
    if T ==1 && G(1)==1 && sum(G) ==1
        IW_ExtraDoses(i,1:3) = [0.01 0.1 1];
    end
    if T ==1 && G(2)==1 && sum(G) ==1
        IW_ExtraDoses(i,1:3) = [0.001 0.1 1];
    end
    if T ==1 && G(3)==1 && sum(G) ==1
        IW_ExtraDoses(i,1:3) = [0.001 0.01 1];
    end
    if T ==1 && G(4)==1 && sum(G) ==1
        IW_ExtraDoses(i,1:3) = [0.001 0.01 0.1];
    end
    if T==1 && G(1) ==1 && G(2)==1 && sum(G) ==2
        IW_ExtraDoses(i,1:2) = [0.1 1];
    end
    if T==1 && G(2) ==1 && G(3)==1 && sum(G) ==2
        IW_ExtraDoses(i,1:2) = [0.001 1];
    end
    if T==1 && G(3) ==1 && G(4)==1 && sum(G) ==2
        IW_ExtraDoses(i,1:2) = [0.001 0.01];
    end
    if T==1 && G(1) ==1 && G(4)==1 && sum(G) ==2
        IW_ExtraDoses(i,1:2) = [0.01 0.1];
    end
    if T==1 && G(1) ==1 && G(3)==1 && sum(G) ==2
        IW_ExtraDoses(i,1:2) = [0.001 1];
    end
    if T==1 && G(2) ==1 && G(4)==1 && sum(G) ==2
        IW_ExtraDoses(i,1:2) = [0.001 0.1];
    end
    if T==1 && G(1)==1&& G(2) ==1 && G(3)==1 && sum(G) ==3
        IW_ExtraDoses(i,1) = [1];
    end
    if T==1 && G(1)==1&& G(2) ==1 && G(4)==1 && sum(G) ==3
        IW_ExtraDoses(i,1) = [0.1];
    end
    if T==1 && G(2)==1&& G(3) ==1 && G(4)==1 && sum(G) ==3
        IW_ExtraDoses(i,1) = [0.001];
    end
    if T==1 && G(1)==1&& G(3) ==1 && G(4)==1 && sum(G) ==3
        IW_ExtraDoses(i,1) = [0.01];
    end
    H = any(IW_DosesData(:)> 0.01);
    R = all(IW_DosesData(:)<1);
    K = ismember([0.1],IW_DosesData(:));
    if H==1 && R ==1  && K(1)==0
        IW_ExtraDoses(i,1) = [0.1];
    end
    H = any(IW_DosesData(:)> 0);
    R = all(IW_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],IW_DosesData(:));
    if H==1 && R ==1  && K(1)==0 && K(2) ==0 && K(3) ==0
        IW_ExtraDoses(i,1:3) = [0.001 0.01 0.1];
    end
    H = any(IW_DosesData(:)> 0);
    R = all(IW_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],IW_DosesData(:));
    if H==1 && R ==1  && K(1)==1 && K(2) ==0 && K(3) ==0
        IW_ExtraDoses(i,1:2) = [0.01 0.1];
    end
    H = any(IW_DosesData(:)> 0);
    R = all(IW_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],IW_DosesData(:));
    if H==1 && R ==1  && K(1)==0 && K(2) ==1 && K(3) ==0
        IW_ExtraDoses(i,1:2) = [0.001 0.1];
    end
    H = any(IW_DosesData(:)> 0);
    R = all(IW_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],IW_DosesData(:));
    if H==1 && R ==1  && K(1)==0 && K(2) ==0 && K(3) ==1
        IW_ExtraDoses(i,1:2) = [0.001 0.01];
    end
    H = any(IW_DosesData(:)> 0);
    R = all(IW_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],IW_DosesData(:));
    if H==1 && R ==1  && K(1)==1 && K(2) ==1 && K(3) ==0
        IW_ExtraDoses(i,1) = [0.1];
    end
    
    H = any(IW_DosesData(:)> 0);
    R = all(IW_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],IW_DosesData(:));
    if H==1 && R ==1  && K(1)== 0 && K(2) ==1 && K(3) ==1
        IW_ExtraDoses(i,1) = [0.001];
    end
    H = any(IW_DosesData(:)> 0);
    R = all(IW_DosesData(:)<1);
    K = ismember([0.01 0.01 0.1],IW_DosesData(:));
    if H==1 && R ==1  && K(1)==1 && K(2) ==0 && K(3) ==1
        IW_ExtraDoses(i,1) = [0.01];
    end
    
    H1 = any(IW_DosesData(:)> 0.001);
    R1 = all(IW_DosesData(:)<0.1);
    K1 = ismember([0.01],IW_DosesData(:));
    if H1==1 && R1 ==1  && K1(1)==0 && G(1) ==1 && G(2)==0
        IW_ExtraDoses(i,1) = [0.01];
    end
    H2 = any(IW_DosesData(:)> 0);
    R2 = all(IW_DosesData(:)<0.01);
    K2 = ismember([0.001],IW_DosesData(:));
    if H1==1 && R1 ==1  && K1(1)==0
        IW_ExtraDoses(i,1) = [0.001];
    end
    H3 = any(IW_DosesData(:)> 0.001);
    R3 = all(IW_DosesData(:)<1);
    K3 = ismember([0.01 0.1],IW_DosesData(:));
    if H3==1 && R3 ==1  && K3(1)==0 && K3(2)==0
        IW_ExtraDoses(i,1:2) = [0.01 0.1];
    end
end

%Data file for prepared input data to be saved to.
filename = 'IonWorks_Data_Matrix.dat';
fid = fopen(filename,'w');

%Collating all pIC50 values with doses simulations
%for each compound should be performed at.
for i = 1:length(IW_Compounds)
    
    IW_FullDoseMatrix(i,1:length(unique(nonzeros(IW_ExtraDoses(i,:))))) = unique(nonzeros(IW_ExtraDoses(i,1:length(unique(IW_ExtraDoses(i,:))))));
    IW_FullDoseMatrix(i,(length(unique(nonzeros(IW_ExtraDoses(i,:))))+1):(length(unique(nonzeros(IW_ExtraDoses(i,:))))+length(unique(IW_Doses(i,:))))) = IW_Doses(i,1:length(unique(IW_Doses(i,:))));
    IW_FullDoseMatrix(i,:) = sort(IW_FullDoseMatrix(i,:));
end
%Calculating number of doses (excluding zero) for each compound
for i = 1:length(IW_FullDoseMatrix)
    IW_NumberOfDoses(i,1) = length(nonzeros(IW_FullDoseMatrix(i,:)));
end
%Collating final matrix

for i = 1:length(IW_Compounds)
    IW_Matrix(:,2:8) = IW_Compound_Data(:,2:8);
    IW_Matrix(:,9) = IW_NumberOfDoses + 1;
    IW_Matrix(:,10) = 0;
    ind= find(IW_FullDoseMatrix(i,:)~=0);
    IW_Matrix(i,11:(11.+(max(ind)-min(ind))))= IW_FullDoseMatrix(i,min(ind):max(ind));
end
IW_Matrix(:,1) = IW_Compounds(:,1);

for i = 1:length(IW_Matrix)
    if i~=length(IW_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f \n',IW_Matrix(i,:));
    end
    if i ==length(IW_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f',IW_Matrix(i,:));
    end
end
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Sorting IonWorks data (including Iks) which has been fitted for IC50 value only
%Extracting pIC50 values and converting to IC50 values
p = 1;
for i = 1:length(Names)
    if strcmp(Assay(i),'IonWorks_FLIPR')==1
        IW2_Compound_Data(p,1) = 1e6.*(10.^(-pIC50Matrix(i,4)));
        IW2_Compound_Data(p,2) = 1;
        p = p+1;
    end
end
%Data file for prepared input data to be saved to.
filename = 'IonWorks_With_Iks_Data_Matrix.dat';
fid = fopen(filename,'w');


%Collating final matrix

for i = 1:length(IW_Compounds)
    IW2_Matrix(:,1:8) = IW_Compound_Data(:,1:8);
    IW2_Matrix(:,9:10) = IW2_Compound_Data(:,1:2);
    IW2_Matrix(:,11) = IW_NumberOfDoses + 1;
    IW2_Matrix(:,12) = 0;
    ind= find(IW_FullDoseMatrix(i,:)~=0);
    IW2_Matrix(i,13:(13.+(max(ind)-min(ind))))= IW_FullDoseMatrix(i,min(ind):max(ind));
end
IW2_Matrix(:,1) = IW_Compounds(:,1);

for i = 1:length(IW2_Matrix)
    if i ~=length(IW2_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f \n',IW2_Matrix(i,:));
    end
    if i==length(IW2_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f',IW2_Matrix(i,:));
    end
end
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Preparing data fitted for IC50 value and Hill coefficient.

% Reads in pIC50 values
fid = fopen('pIC50_Values_And_Hill_Coefficients.dat');
Namedata = textscan(fid, '%f %s %f %f %f %f %f %f %f %f ','headerlines',1);
fclose(fid);
Names = Namedata{1};
Assay = Namedata{2};
DataMatrix{1} = Namedata{3};
DataMatrix{2} = Namedata{4};
DataMatrix{3} = Namedata{5};
DataMatrix{4} = Namedata{6};
DataMatrix{5} = Namedata{7};
DataMatrix{6} = Namedata{8};
DataMatrix{7} = Namedata{9};
DataMatrix{8} = Namedata{10};
pIC50HillMatrix = cell2mat(DataMatrix);
NamesMatrix = Names;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Sorting PatchXpress data which has been fitted for IC50 value and Hill
% coefficient
% Extracting pIC50 values and Hills and converting to IC50 values
p=1;
for i = 1:length(Names)
    if strcmp(Assay(i),'PatchXpress')==1
        PX2_Compound_Data(p,2) = 0.5;
        PX2_Compound_Data(p,3) = 1e6.*(10.^(-pIC50HillMatrix(i,1)));
        PX2_Compound_Data(p,4) = pIC50HillMatrix(i,2);
        PX2_Compound_Data(p,5) = 1e6.*(10.^(-pIC50HillMatrix(i,3)));
        PX2_Compound_Data(p,6) = pIC50HillMatrix(i,4);
        PX2_Compound_Data(p,7) = 1e6.*(10.^(-pIC50HillMatrix(i,5)));
        PX2_Compound_Data(p,8) = pIC50HillMatrix(i,6);
        p = p+1;
    end
end

%Data file for prepared input data to be saved to.
filename = 'PatchXpress_2Parameter_Data_Matrix.dat';
fid = fopen(filename,'w');

% Collating final matrix
for i = 1:length(PX_Compounds)
    PX2_Matrix(i,1:2) = PX_Matrix(i,1:2);
    PX2_Matrix(i,3:8) = PX2_Compound_Data(i,3:8);
    PX2_Matrix(i,9:20) = PX_Matrix(i,9:20);
end
for i = 1:length(PX2_Matrix)
    if i ~=length(PX2_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f \n',PX2_Matrix(i,:));
    end
    if i ==length(PX2_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f',PX2_Matrix(i,:));
    end
end
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Sorting IonWorks data (excluding Iks) which has been fitted for IC50 value and Hill
% coefficient
% Extracting pIC50 values and Hills and converting to IC50 values
p=1;
for i = 1:length(Names)
    if strcmp(Assay(i),'IonWorks_FLIPR')==1
        IW3_Compound_Data(p,2) = 0.5;
        IW3_Compound_Data(p,3) = 1e6.*(10.^(-pIC50HillMatrix(i,1)));
        IW3_Compound_Data(p,4) = pIC50HillMatrix(i,2);
        IW3_Compound_Data(p,5) = 1e6.*(10.^(-pIC50HillMatrix(i,3)));
        IW3_Compound_Data(p,6) = pIC50HillMatrix(i,4);
        IW3_Compound_Data(p,7) = 1e6.*(10.^(-pIC50HillMatrix(i,5)));
        IW3_Compound_Data(p,8) = pIC50HillMatrix(i,6);
        p = p+1;
    end
end

%Data file for prepared input data to be saved to.
filename = 'IonWorks_2Parameter_Data_Matrix.dat';
fid = fopen(filename,'w');

% Collating final matrix
for i = 1:length(IW_Compounds)
    IW3_Matrix(i,1:2) = IW_Matrix(i,1:2);
    IW3_Matrix(i,3:8) = IW3_Compound_Data(i,3:8);
    IW3_Matrix(i,9:20) = IW_Matrix(i,9:20);
end
for i = 1:length(IW3_Matrix)
    if i ~= length(IW3_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f \n',IW3_Matrix(i,:));
    end
    if i == length(IW3_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f',IW3_Matrix(i,:));
    end
end
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Sorting IonWorks data (including Iks) which has been fitted for IC50 value and Hill
% coefficient
% Extracting pIC50 values and Hills and converting to IC50 values
p=1;
for i = 1:length(Names)
    if strcmp(Assay(i),'IonWorks_FLIPR')==1
        IW4_Compound_Data(p,2) = 0.5;
        IW4_Compound_Data(p,3) = 1e6.*(10.^(-pIC50HillMatrix(i,1)));
        IW4_Compound_Data(p,4) = pIC50HillMatrix(i,2);
        IW4_Compound_Data(p,5) = 1e6.*(10.^(-pIC50HillMatrix(i,3)));
        IW4_Compound_Data(p,6) = pIC50HillMatrix(i,4);
        IW4_Compound_Data(p,7) = 1e6.*(10.^(-pIC50HillMatrix(i,5)));
        IW4_Compound_Data(p,8) = pIC50HillMatrix(i,6);
        IW4_Compound_Data(p,9) = 1e6.*(10.^(-pIC50HillMatrix(i,7)));
        IW4_Compound_Data(p,10) = pIC50HillMatrix(i,8);
        p = p+1;
    end
end

%Data file for prepared input data to be saved to.
filename = 'IonWorks_With_Iks_2Parameter_Data_Matrix.dat';
fid = fopen(filename,'w');

% Collating final matrix
for i = 1:length(IW_Compounds)
    IW4_Matrix(i,1:2) = IW_Matrix(i,1:2);
    IW4_Matrix(i,3:10) = IW4_Compound_Data(i,3:10);
    IW4_Matrix(i,11:22) = IW2_Matrix(i,11:22);
end
for i = 1:length(IW4_Matrix)
    if i ~=length(IW4_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f \n',IW4_Matrix(i,:));
    end
    if i==length(IW4_Matrix)
        fprintf(fid,'%.0f %.1f %.9f %.9f %.9f %.9f %.9f %.9f %.9f %.9f %.0f %.0f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f',IW4_Matrix(i,:));
    end
end
fclose(fid);